#!/bin/sh

# nilfs.sh,v 1.4 2007-05-15 03:46:50 moriai Exp

PATH=/sbin:/bin:/usr/sbin:/usr/bin
VOLS='0'
TIMEOUT=120
UPDATEOPT=

[ -f /etc/default/nilfs ] && . /etc/default/nilfs

losetup -f >/dev/null

case "$1" in
start)
	echo -n "Mounting nilfs devices:"
	for n in $VOLS; do
		losetup /dev/loop$n /var/vols/nilfs$n && echo -n " loop$n"
		case $n in
		0)	x="" ;;
		*)	x=$n ;;
		esac
		if [ ! -d /var/run/autofs ]; then
			mkdir /var/run/autofs
		fi
		automount -p /var/run/autofs/nilfs$x.pid -t $TIMEOUT /nilfs$x program /etc/auto.nilfs.loop$n && echo -n " (/nilfs$x)"
		sleep 1
		if [ ! -d /var/run/nilfs ]; then
			mkdir /var/run/nilfs
		fi
		updatecp "$UPDATEOPT" /nilfs$x 11 &
	done
	echo "."
	;;

stop)
	echo -n "Unmounting nilfs devices:"
	for n in $VOLS; do
		case $n in
		0)	x="" ;;
		*)	x=$n ;;
		esac
		kill -TERM `cat /var/run/nilfs/nilfs${x}.pid`
		while [ -f /var/run/autofs/nilfs$x.pid ]; do
			kill -TERM `cat /var/run/autofs/nilfs$x.pid`
			sleep 1
		done
		if losetup /dev/loop$n >/dev/null 2>&1; then
			losetup -d /dev/loop$n && echo -n " loop$n"
		fi
	done
	echo "."
	;;

restart)
	sh "$0" stop
	sh "$0" start
	;;

*)
	echo "Usage: /etc/init.d/nilfs start|stop|restart"
	exit 1
	;;
esac

exit 0
